/* Copyright (c) 2001-2004 by SoftIntegration, Inc. All Rights Reserved */
/*************************************************** 
*   Filename - callch.ch 
*   The function chfun() will be called from c space
****************************************************/

#include<dlfcn.h>

void callch() {
  void *dlhandle, *fptr;

  dlhandle = dlopen("libcallch.dl", RTLD_LAZY);
  if(dlhandle == NULL) {
    fprintf(_stderr, "Error: %s(): dlopen(): %s\n", 
                      __func__, dlerror());
    return;
  }

  fptr = dlsym(dlhandle, "callch_chdl");
  if(fptr == NULL) {
    printf("Error: %s(): dlsym(): %s\n", __func__, dlerror());
    return;
  }

  dlrunfun(fptr, NULL, callch);

  if(dlclose(dlhandle)!=0) {
    fprintf(_stderr, "Error: %s(): dlclose(): %s\n", 
                      __func__, dlerror());
    return;
  }

  return;
}

/* this function will be called from a C function */
int chfun(int arg1) {
  printf("in the Ch function, arg1 = %d\n", arg1);
  return arg1 * arg1;
}

int main() {
  callch();
  return 0;
}
